<?php
/**
 * The template for displaying Archive pages
 *
 * Used to display archive-type pages if nothing more specific matches a query.
 * For example, puts together date-based pages if no date.php file exists.
 *
 * If you'd like to further customize these archive views, you may create a
 * new template file for each specific one. For example, Twenty Fourteen
 * already has tag.php for Tag archives, category.php for Category archives,
 * and author.php for Author archives.
 *
 * @link http://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Twenty_Fourteen
 * @since Twenty Fourteen 1.0
 */

get_header(); ?>

<div id="main-content" class="main-content">	
<section class="subpage-banner">
<div class="subpage-title">
    <div class="container">
        <h3>
					<?php
						if ( is_day() ) :
							printf( __( 'Daily Archives: %s', 'twentyfourteen' ), get_the_date() );

						elseif ( is_month() ) :
							printf( __( 'Monthly Archives: %s', 'twentyfourteen' ), get_the_date( _x( 'F Y', 'monthly archives date format', 'twentyfourteen' ) ) );

						elseif ( is_year() ) :
							printf( __( 'Yearly Archives: %s', 'twentyfourteen' ), get_the_date( _x( 'Y', 'yearly archives date format', 'twentyfourteen' ) ) );

						else :
							_e( 'Archives', 'twentyfourteen' );

						endif;
					?>
				</h3>
    </div>
</div>
<div class="breadcrumb-holder">
<div class="container">
    <ul class="breadcrumb">
     <li><a href="../">Home</a></li>
     <li><a href="<?=home_url('/');?>">Blog</a></li>
     <li class="active"><?php
						if ( is_day() ) :
							printf( __( 'Daily Archives: %s', 'twentyfourteen' ), get_the_date() );

						elseif ( is_month() ) :
							printf( __( 'Monthly Archives: %s', 'twentyfourteen' ), get_the_date( _x( 'F Y', 'monthly archives date format', 'twentyfourteen' ) ) );

						elseif ( is_year() ) :
							printf( __( 'Yearly Archives: %s', 'twentyfourteen' ), get_the_date( _x( 'Y', 'yearly archives date format', 'twentyfourteen' ) ) );

						else :
							_e( 'Archives', 'twentyfourteen' );

						endif;
					?></li>
    </ul>
</div>
</div>
</section>
			<section class="section-single blog-tt-columns blog-wrapper dm-shadow">
    	<div class="container">
			<div class="single-post-wrapper col-lg-9 col-md-9 col-sm-12 clearfix">
				
				<?php 
				$i=0;
				if ( have_posts() ) :
					while ( have_posts() ) : the_post(); $i++; ?>
				
					<article class="blog-wrap col-lg-6 col-md-6 col-sm-12 clearfix <?=$i%2==0?'last':'first'?>">
				
						<? $category = get_the_category(); ?>
				
							<!-- end blog media -->
				
								<div class="post-date">
									<span class="day"><?php echo get_the_date('d'); ?></span>
									<span class="month"><?php echo get_the_date('M'); ?></span>
								</div><!-- end post-date -->
								
								<div class="post-content">
									<h2><a href="<?=the_permalink();?>"><? the_title();?></a></h2>
										<p><?=the_excerpt();?></p>
										
									<div class="post-meta">
										<span><i class="fa fa-user"></i> <a href="author/<?=get_the_author_meta("user_nicename",$post->post_author);?>"><?=get_the_author();?></a> </span>
										<span><i class="fa fa-tag"></i> <a href="category/<?=$category[0]->slug;?>"><?=$category[0]->name;?></a></span>
										<a href="<?=the_permalink();?>" class="btn btn-primary btn-xs pull-right">read more</a>
									</div>
								</div><!-- post-content -->
                	</article><!-- end blog wrap -->
					<? 

				endwhile;
				//wp_reset_query(); 
				 wp_pagenavi(); 

			else :
				// If no content, include the "No posts found" template.
				get_template_part( 'content', 'none' );

		endif;
		?>
     </div>               
                   
            
             <?php get_sidebar('right'); ?>  
           </div>
	</section>
	</div>

<?php
get_sidebar( 'content' );
get_sidebar();
get_footer();
