<?php
/**
 * The main template file
 *
 * This is the most generic template file in a WordPress theme and one
 * of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query,
 * e.g., it puts together the home page when no home.php file exists.
 *
 * @link http://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Twenty_Fourteen
 * @since Twenty Fourteen 1.0
 */

get_header(); ?>

<div id="main-content" class="main-content">

<?php
	if ( is_front_page() && twentyfourteen_has_featured_posts() ) {
		// Include the featured content template.
		get_template_part( 'featured-content' );
	}
?>

<div class="post-wrapper-top">
   <div class="container">
	<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 pull-left">
	 <h1>Blog</h1>
	</div>
   </div>
   <div class="page-top-breadcrumb">
    <div class="container">
	 <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 pull-left">
	  <ul class="breadcrumb">
	   <li><a href="../">Home</a></li>
	   <li class="active">Blog</li>
	  </ul>
	 </div>
	</div>
   </div>
   <div class="clear"></div>
  </div>
   
  <div class="section-whitebg blog-tt-columns blog-wrapper dm-shadow">
    	<div class="container">
			<div class="single-post-wrapper">
               <div class="row">
               
			<?php
					$i=0;
					 if ( have_posts() ) : ?>
					<?php 
					while ( have_posts() ) : the_post(); $i++; ?>
					<article class="blog-wrap col-lg-4 col-md-4 col-sm-12 clearfix ">
				
							<div class="entry blog-media">
                            <?php if(has_post_thumbnail(get_the_id())) { ?>								
							<a href="<?=get_permalink(get_the_id());?>"><img src="<?=wp_get_attachment_url(get_post_thumbnail_id(get_the_id()));?>" class="img-responsive thumbnail" alt="<?=the_title();?>" />
                            <span class="magnifier"></span></a>
                            <?php }else{?>
                            <a href="<?=get_permalink(get_the_id());?>"><img src="../images/no_blog.jpg" class="img-responsive thumbnail" alt="<?=the_title();?>" /></a>
                            <? } ?>
							</div>
				
								<div class="post-date">
									<span class="day"><?php echo get_the_date('d'); ?></span>
									<span class="month"><?php echo get_the_date('M'); ?></span>
								</div>
								
								<div class="post-content clearfix">
									<h2><a href="<?=the_permalink();?>"><? the_title();?></a></h2>
										 <?php the_excerpt();?> 
										
									<div class="post-meta clearfix">
										<a href="<?=the_permalink();?>" class="btn btn-primary pull-right">Read More</a>
									</div>
								</div>
                	</article>
					<?=($i%3==0)?'<div class="clear"></div>':'';?>
					<?php  endwhile; ?>
                         <div class="clear"></div>
					<?php
				wp_pagenavi();
			else :
				// If no content, include the "No posts found" template.
				get_template_part( 'content', 'none' );

		endif;
		?>
        </div>
     </div>            
              
        </div>  
       </div>
</div><!-- #main-content -->

<?php 
 get_footer();
 ?>