<?php
/**
 * The header for our theme
 *
 * This is the template that displays all of the <head> section and everything up until <div id="content">
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package WordPress
 * @subpackage Twenty_Seventeen
 * @since 1.0
 * @version 1.0
 */

?><!DOCTYPE html>
<html <?php language_attributes(); ?> class="no-js no-svg">
<base href="<?=home_url("/");?>">
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="profile" href="http://gmpg.org/xfn/11">
<link href="../assets/css/bootstrap.css" rel="stylesheet">
<link href="../css/owl.carousel.css" rel="stylesheet">
<link rel="shortcut icon" href="../assets/ico/favicon.ico" type="image/x-icon">
<?php wp_head(); ?>
<link href="../css/style.css" rel="stylesheet">

</head>

<body class="subpages" <?php //body_class(); ?>>
<div id="wrapper" class="site">
	<a class="skip-link screen-reader-text" href="#content"><?php _e( 'Skip to content', 'twentyseventeen' ); ?></a>
	<div class="header-section subpage-hdr">  
	<header class="header-wrapper clearfix" data-spy="affix" data-offset-top="60" data-offset-bottom="200">
      <div class="container">
        <div class="navbar-area">
          <nav class="clearfix text-center">
            <div class="wsmenucontent overlapblackbg"></div>
            <div class="wsmenuexpandermain"><a id="navToggle" class="animated-arrow slideLeft"><span></span></a></div>
            <div class="site-title" id="title"><a href="../"> <img src="../images/zooliad.png" alt="Zooliad in [Dynamic1]"></a> </div>
            <div class="nav-right pull-right">
                <div class="wsmenu slideLeft pull-left">
                  <ul class="mobile-sub wsmenu-list pull-left">
                    <li><a href="../">Home</a></li>
                    <li><a href="../about-us">ABOUT US</a></li>
                    <li class="sub-list"><a href="javascript:;">Services</a>
                        <ul class="wsmenu-submenu lstmenu">
                        <li>
                         <div class="row">
                          <div class="pull-left col-lg-6 col-md-6 col-sm-6 col-xs-12">
                          <ul>
                          <li><a href="../website-speed"><span class="menuicon icon-webspeed">Website Speed</span></a></li>
                          <li><a href="../management"><span class="menuicon icon-management">Management</span></a></li>
                          <li><a href="../safety-plans"><span class="menuicon icon-safety-plans">Safety Plans</span></a></li>
                          <li><a href="../backup"><span class="menuicon icon-backup">Backup</span></a></li>
                          <li><a href="../maintenance"><span class="menuicon icon-maintenance">Maintenance</span></a></li>
                          <li><a href="../malware-removal"><span class="menuicon icon-malware-removal">Malware Removal</span></a></li>
                            </ul>
                          </div>
                          <div class="pull-right col-lg-6 col-md-6 col-sm-6 col-xs-12">
                          <ul>
                          <li><a href="../migration"><span class="menuicon icon-migration">Migration</span></a></li>
                          <li><a href="../recovery"><span class="menuicon icon-recovery">Recovery</span></a></li>
                          <li><a href="../theme-customization"><span class="menuicon icon-theme-customization">Theme Customization</span></a></li>
                          <li><a href="../updates"><span class="menuicon icon-theme-updates">Updates</span></a></li>
                          <li><a href="../e-commerce-diagnosis-and-fixes"><span class="menuicon icon-ecommerce">E-commerce diagnosis and fixes</span></a></li>
                           </ul>
                          </div>
                         </div>
                        </li>
                       </ul>
                    </li>
                    <li><a href="../pricing">Pricing</a></li>
                    <li><a href="../contact-us">Contact Us</a></li>
                    <li class="nav-get"><a href="../get-started">GET STARTED</a></li>
                  </ul>
                </div>
            </div>
          </nav>
        </div>
      </div>
	</header>
	</div>
	<div class="site-content-contain">
		<div id="content" class="section-whitebg white-bg first-bg price-main site-content">
